#region using

using System;
using System.Web;
using System.Web.UI;
using BlogEngine.Core.Web.Controls;
using BlogEngine.Core;
using System.Text.RegularExpressions;
using System.Collections.Generic;

#endregion

/// <summary>
/// Auto make a slug in md5 format for every post which is no slug.
/// </summary>
[Extension("ԶδָָһMD5ʽı", "1.0", "<a href=\"http://www.blogyi.net\">BlogYi.NET</a>")]
public class AutoMd5Slug
{
    /// <summary>
    /// Hooks up an event handler to the Post.Serving event.
    /// </summary>
    static AutoMd5Slug()
    {
        Post.Saving += new EventHandler<SavedEventArgs>(Post_Saving);
    }

    /// <summary>
    /// Handles the Post.Saving event.
    /// </summary>
    private static void Post_Saving(object sender, SavedEventArgs e)
    {
        Post post = (Post)sender;
        if (post.IsNew)
        {
            post.Slug = MakeMD5(post.Title, 16);
        }
    }

    public static string MakeMD5(string str, int code)
    {
        if (code == 16)
        {
            //16λMD5ܣȡ32λܵ9-25ַ
            return System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(str, "MD5").ToLower().Substring(8, 16);
        }
        else
        {
            //32λ
            return System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(str, "MD5").ToLower();
        }
    }
}